/**
 * This is a Demonstration Only Java Files
 */
package sbt.sample.standalone.java;

import com.ibm.sbt.services.client.connections.forums.Forum;
import com.ibm.sbt.services.client.connections.forums.ForumList;
import com.ibm.sbt.services.client.connections.forums.ForumService;
import com.ibm.sbt.services.client.connections.forums.ForumServiceException;
import com.ibm.sbt.services.client.connections.forums.ForumTopic;
import com.ibm.sbt.services.client.connections.forums.TopicList;
import com.ibm.sbt.services.client.connections.forums.model.BaseForumEntity;
import com.ibm.sbt.services.endpoints.BasicEndpoint;
import com.ibm.sbt.services.endpoints.ConnectionsBasicEndpoint;

public class StandaloneDemo {

	public static void main(String[] args) {
		String url = args[0];
		String user = args[1];
		String password = args[2];
		
		StandaloneDemo demo = new StandaloneDemo(url, user, password);
		ForumService svc = new ForumService(demo.endpoint);
		try {
			ForumList forumList = svc.getAllForums();
			for(BaseForumEntity forumEntity : forumList){
				Forum forum = (Forum) forumEntity;
				System.out.println("+F: " + forum.getTitle());
				TopicList topics = forum.getTopics();
				
				for(BaseForumEntity topicEntity : topics){
					ForumTopic topic = (ForumTopic) topicEntity;
					System.out.println("-- " + topic.getTitle());
				}
				
			}
			
		} catch (ForumServiceException e) {
			e.printStackTrace();
		}
		
	}
	
	/**
	 * returns the endpoint
	 * @return
	 */
	public BasicEndpoint getEndpoint(){
		return endpoint;
	}
	
	BasicEndpoint endpoint;
	
	/**
	 * creates the basicendpoint wrapped in the demo class
	 * @param url
	 * @param user
	 * @param password
	 */
	StandaloneDemo(String url, String user,
			String password){
		endpoint = createEndpoint(url,user,password);
	}

	/**
	 * creates a new Basic Endpoint to connect to Connections
	 * 
	 * @param url
	 * @param user
	 * @param password
	 * @return
	 */
	private BasicEndpoint createEndpoint(String url, String user,
			String password) {
		BasicEndpoint endpoint = new ConnectionsBasicEndpoint();
		endpoint.setUrl(url);
		endpoint.setUser(user);
		endpoint.setPassword(password);
		endpoint.setForceTrustSSLCertificate(true);
		return endpoint;
	}
}
